#include <iostream>
#include <algorithm>
const int MAX_N = 510, mod = 1e9 + 7;

int mat[MAX_N * MAX_N], ans[MAX_N * MAX_N];

int main()
{
    std::cin.tie();
    std::ios_base::sync_with_stdio(false);

    int n, m, nm;
    std::cin >> n >> m;
    nm = n * m;

    for(int i = 0; i < nm; ++ i)
    {
        std::cin >> mat[i];
    }

    std::sort(mat, mat + nm);

    ans[nm - 1] = 1;

    for(int i = nm - 2; i >= 0; -- i)
    {
        if(mat[i] == mat[i + 1])
        {
            ans[i] = ans[i + 1];
        }else
        {
            ans[i] = (ans[i + 1] + ans[i + 2]) % mod;
        }
    }

    std::cout << ans[0] << '\n';

    return 0;
}
/*
3 4
26 17 19 26
19 21 33 19
10 13 42 28
10 13 17 19 19 19 21 26 26 28 33 42
*/
