#include <iostream>
using namespace std;
char field[1001][1001];
int bombs[1001][1001], n;
bool used[1001][1001];
void init()
{
    cin>>n;
    for (int i=1; i<=n; i++){
        for (int j=1; j<=n; j++){
            cin>>field[i][j];
        }
    }
    for (int i=1; i<=n; i++){
        for (int j=1; j<=n; j++){
            if (field[i][j]=='@'){
                bombs[i][j]=-1;
                if (bombs[i][j-1]!=-1) bombs[i][j-1]++;
                if (bombs[i][j+1]!=-1) bombs[i][j+1]++;
                if (bombs[i-1][j]!=-1) bombs[i-1][j]++;
                if (bombs[i-1][j-1]!=-1) bombs[i-1][j-1]++;
                if (bombs[i-1][j+1]!=-1) bombs[i-1][j+1]++;
                if (bombs[i+1][j]!=-1) bombs[i+1][j]++;
                if (bombs[i+1][j-1]!=-1) bombs[i+1][j-1]++;
                if (bombs[i+1][j-1]!=-1) bombs[i+1][j+1]++;
            }
        }
    }
}
int rec(int x, int y, int prev)
{
    int br=0;
    bool xm1=false, xp1=false, ym1=false, yp1=false;
    //if (x==3 and y==4) cout<<"prev = "<<prev<<endl;
    if (used[x][y]) return 0;
    used[x][y]=true;
    if (bombs[x][y]==-1) return 0;
    if (prev==0 and bombs[x][y]!=0) return 0;
    if (bombs[x][y]!=0) return 1;

    if (y-1>0) ym1=true;
    if (y+1<=n) yp1=true;
    if (x-1>0) xm1=true;
    if (x+1<=n) xp1=true;

    if (ym1) br=br+rec(x, y-1, bombs[x][y]);
    if (yp1) br=br+rec(x, y+1, bombs[x][y]);
    if (xm1) br=br+rec(x-1, y, bombs[x][y]);
    if (xm1 and ym1) br=br+rec(x-1, y-1, bombs[x][y]);
    if (xm1 and yp1) br=br+rec(x-1, y+1, bombs[x][y]);
    if (xp1) br=br+rec(x+1, y, bombs[x][y]);
    if (xp1 and ym1) br=br+rec(x+1, y-1, bombs[x][y]);
    if (xp1 and yp1) br=br+rec(x+1, y+1, bombs[x][y]);

    //if (prev==0) br=0;

    return br;
}
int main()
{
    int br=0, neshto;
    init();
    //bombs[3][4]=22;
    /*for (int i=1; i<=n; i++){
        for (int j=1; j<=n; j++){
            cout<<bombs[i][j]<<" ";
        }
        cout<<endl;
    }*/
    //cout<<rec(3, 4, -2)<<endl;
    for (int i=1; i<=n; i++){
        for (int j=1; j<=n; j++){
            if (!used[i][j] and bombs[i][j]==0){
                //if (bombs[i][j]!=-1) cout<<"("<<i<<"; "<<j<<")\n";
                neshto=rec(i, j, -2);
                if (bombs[i][j]!=-1) br++;
            }
        }
    }
    for (int i=1; i<=n; i++){
        for (int j=1; j<=n; j++){
            if (!used[i][j]){
                //if (bombs[i][j]!=-1) cout<<"("<<i<<"; "<<j<<")\n";
                neshto=rec(i, j, -2);
                if (bombs[i][j]!=-1) br++;
            }
        }
    }
    cout<<br<<endl;

    return 0;
}
/**
9
...@..@..
.........
.........
...@..@..
....@....
.........
@@..@...@
.......@.
.........
----------------
7
.......
..@@@..
..@.@..
..@@@..
.......
.......
.......
*/
