#include <bits/stdc++.h>

using namespace std;

#define print(x) cout << #x << " = " << x << endl;
typedef long long ll;
typedef unsigned long long ull;

bool grid[1010][1010], used[1010][1010];
ll pole[1010][1010];
ll n;
ll bombi, obh, brcomp;

/*
9
...@..@..
.........
.........
...@..@..
....@....
.........
@@..@...@
.......@.
.........
*/

void bfs(int sx, int sy) {
    queue<pair<int, int> > q;
    q.push({sx, sy});
    obh ++;
    used[sx][sy] = true;
    while(!q.empty()) {
        pair<int, int> curr = q.front();
        q.pop();
        if(pole[curr.first][curr.second] == 0)
            for(int ki = -1; ki < 2; ki ++) {
                for(int kj = -1; kj < 2; kj ++) {
                    if((curr.first + ki) < 1 || (curr.first + ki) > n || (curr.second + kj) < 1 || (curr.second) + kj > n || used[curr.first + ki][curr.second + kj] || grid[curr.first + ki][curr.second + kj]) {
                        continue;
                    } else {
                        used[curr.first + ki][curr.second + kj] = true;
                        obh ++;
                        q.push({curr.first + ki, curr.second + kj});
                    }
                }
            }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n;
    for(int i = 0; i < n; i ++) {
        for(int j = 0; j < n; j ++) {
            char c;
            cin >> c;
            grid[i + 1][j + 1] = (c == '@');
        }
    }
    for(int i = 1; i <= n; i ++) {
        for(int j = 1; j <= n; j ++) {
            if(grid[i][j]) {
                pole[i][j] = -1;
            } else {
                for(int ki = -1; ki < 2; ki ++) {
                    for(int kj = -1; kj < 2; kj ++) {
                        pole[i][j] += (int)(grid[i + ki][j + kj]);
                    }
                }
            }
        }
    }
    for(int i = 1; i <= n; i ++) {
        for(int j = 1; j <= n; j ++) {
            if(!used[i][j]) {
                if(pole[i][j] > 0)
                    continue;
                bfs(i, j);
                brcomp ++;
            }
        }
    }
    for(int i = 1; i <= n; i ++) {
        for(int j = 1; j <= n; j ++) {
            if(!used[i][j]) {
                if(pole[i][j] < 0)
                    continue;
                bfs(i, j);
                brcomp ++;
            }
        }
    }
    cout << brcomp;
    return 0;
}
