#include <bits/stdc++.h>

using namespace std;

#define print(x) cout << #x << " = " << x << endl;
typedef long long ll;
typedef unsigned long long ull;

bool grid[1010][1010], used[1010][1010];
int pole[1010][1010];
ll n;
ll bombi, obh, brcomp;

void bfs(int sx, int sy) {
    queue<pair<int, int> > q;
    q.push({sx, sy});
    while(!q.empty()) {
        pair<int, int> curr = q.front();
        q.pop();
        if(curr.first < 1 || curr.first > n || curr.second < 1 || curr.second > n || used[curr.first][curr.second] || grid[curr.first][curr.second])
            continue;
        used[curr.first][curr.second] = true;
        obh ++;
        if(pole[curr.first][curr.second] == 0)
            for(int ki = -1; ki < 2; ki ++) {
                for(int kj = -1; kj < 2; kj ++) {
                    q.push({curr.first + ki, curr.second + kj});
                }
            }
    }
}

int main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(NULL);
    cin >> n;
    for(int i = 0; i < n; i ++) {
        for(int j = 0; j < n; j ++) {
            char c;
            cin >> c;
            grid[i + 1][j + 1] = (c == '@');
            if(grid[i + 1][j + 1])
                bombi ++;
        }
    }
    for(int i = 1; i <= n; i ++) {
        for(int j = 1; j <= n; j ++) {
            if(grid[i][j]) {
                pole[i][j] = -1;
            } else {
                for(int ki = -1; ki < 2; ki ++) {
                    for(int kj = -1; kj < 2; kj ++) {
                        pole[i][j] += (int)(grid[i + ki][j + kj]);
                    }
                }
            }
        }
    }
    for(int i = 1; i <= n; i ++) {
        for(int j = 1; j <= n; j ++) {
            if(!used[i][j] && pole[i][j] == 0) {
                bfs(i, j);
                brcomp ++;
            }
        }
    }
    cout << n * n + brcomp - bombi - obh << "\n";
    return 0;
}
