#include<algorithm>
#include<iostream>
#include<stack>
using namespace std;

const int MOD=1000000007;

int a[250005];
unsigned int next[250005];
int dp[250005];

int main()
{
    int n,m;
    cin >> n >> m;

    int d=n*m;

    for(int i=0; i<d; i++)
        cin >> a[i];

    sort(a,a+d);

    stack<int> st;
    st.push(d-1);
    next[d-1]=d;

    for(int i=d-2; i>=0; i--)
    {
        next[i]=d;
        while(!st.empty() and a[st.top()]<=a[i]) st.pop();
        next[i]=st.top();
        st.push(i);
    }

    dp[0]=1;
    for(int i=0; i<d-1; i++)
    {
        if(next[i]+1<d)
        {
            dp[next[i]]+=dp[i];
            dp[next[i]]%=MOD;
            dp[next[i]+1]+=dp[i];
            dp[next[i]+1]%=MOD;
        }
        else
        {
            dp[next[i]]+=dp[i];
            dp[next[i]]%=MOD;
        }
    }

    cout << dp[d-1] << endl;

    return 0;
}
