#include<algorithm>
#include<iostream>
#include<stack>
using namespace std;

const int MOD=1000000007;

int a[250005];
int nxt[250005];
int dp[250005];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n,m;
    cin >> n >> m;

    int d=n*m;

    for(int i=0; i<d; i++)
        cin >> a[i];

    sort(a,a+d);

    stack<int> st;
    st.push(d-1);
    nxt[d-1]=d;

    for(int i=d-2; i>=0; i--)
    {
        nxt[i]=d;
        while(!st.empty() and a[st.top()]<=a[i]) st.pop();
        if(!st.empty()) nxt[i]=st.top();
        st.push(i);
    }

    dp[0]=1;
    for(int i=0; i<d-1; i++)
    {
        dp[nxt[i]]+=dp[i];
        dp[nxt[i]]%=MOD;
        if(nxt[i]+1<d)
        {
            dp[nxt[i]+1]+=dp[i];
            dp[nxt[i]+1]%=MOD;
        }
    }

    cout << dp[d-1] << endl;

    return 0;
}
