#include<iostream>
#include<queue>
using namespace std;

int mat[1024][1024];
int st[1024][1024];
int n, found, mine, ans;
char vh;
bool used[1024][1024];
queue<pair<int, int> > open;

void dfs(int x, int y)
{
    if(used[x][y]){
        return;
    }
    used[x][y] = true;
    found++;
    if(st[x][y] > 0){
        return;
    }
    if(x > 1){
        if(y > 1){
            dfs(x-1, y-1);
        }
        dfs(x-1, y);
        if(y < n){
            dfs(x-1, y+1);
        }
    }

    if(y > 1){
        dfs(x, y-1);
    }
    if(y < n){
        dfs(x, y+1);
    }

    if(x < n){
        if(y > 1){
            dfs(x+1, y-1);
        }
        dfs(x+1, y);
        if(y < n){
            dfs(x+1, y+1);
        }
    }
}

int main(){
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);
    cin >> n;

    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= n; j++){
            cin >> vh;
            if(vh == '@'){
                mat[i][j] = 1;
                mine++;
            }
        }
    }
    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= n; j++){
            if(mat[i][j]){
                st[i][j] = 1224;
                continue;
            }
            st[i][j] = mat[i-1][j-1] + mat[i-1][j] + mat[i-1][j+1] + mat[i][j-1]
                     + mat[i][j+1] + mat[i+1][j-1] + mat[i+1][j] + mat[i+1][j+1];
            if(st[i][j] == 0){
                open.push({i, j});
                //cout << i << " " << j << endl;
            }
            //cout << st[i][j];
        }
        //cout << endl;
    }
    while(!open.empty()){
        pair<int, int> dot = open.front();
        int x = dot.first;
        int y = dot.second;
        open.pop();
        if(!used[x][y]){
            ans++;
            dfs(x, y);
            //cout << x << " " << y << " " << found << endl;
        }
    }
    ans += n*n - found - mine;
    /*for(int i = 1; i <= n; i++){
        for(int j = 1; j <= n; j++){
            if(!used[i][j]){

            }
        }
    }*/
    cout << ans << endl;
return 0;
}
/*
9
...@..@..
.........
.........
...@..@..
....@....
.........
@@..@...@
.......@.
.........
*/
