#include <iostream>
using namespace std;
char a[1001][1001];
int t[1001][1001];
bool used[1001][1001];
int mov[8][2]={{0,1},{1,0},{0,-1},{-1,0},{1,1},{1,-1},{-1,1},{-1,-1}};
int us, n, x, y;
void dfs(int i, int j) {
    used[i][j]=true;
    us++;
    if (t[i][j]>0) return;
    for (int k=0;k<8;k++) {
        x=i+mov[k][0];
        y=j+mov[k][1];
        if (x<0 or x>=n or y<0 or y>=n) continue;
        if (!used[x][y]) dfs(x,y);
    }
}
int main () {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    for (int i=0;i<n;i++) {
        for (int j=0;j<n;j++) {
            cin >> a[i][j];
        }
    }
    int x, y;
    for (int i=0;i<n;i++) {
        for (int j=0;j<n;j++) {
            if (a[i][j]=='.') {
                for (int k=0;k<8;k++) {
                    x=i+mov[k][0];
                    y=j+mov[k][1];
                    if (x<0 or x>=n or y<0 or y>=n) continue;
                    if (a[x][y]=='@') t[i][j]++;
                }
            } else {
                us++;
                used[i][j]=true;
            }
        }
    }
    int ans=0;
    for (int i=0;i<n;i++) {
        for (int j=0;j<n;j++) {
            if (!used[i][j] and t[i][j]==0) {
                dfs(i,j);
                ans++;
            }
        }
    }
    ans+=(n*n-us);
    cout << ans << endl;
    return 0;
}
/**
9
...@..@..
.........
.........
...@..@..
....@....
.........
@@..@...@
.......@.
.........
**/
