#include <iostream>

const int MAX_N = 1010;
int mat[MAX_N][MAX_N];
bool would[MAX_N][MAX_N];
int ans = 0;

void _fill(int n)
{
    for(int i = 0; i < n; ++ i)
    {
        for(int j = 0; j < n; ++ j)
        {
            mat[i][j] = 9;
        }
    }
}

void read(int n)
{
    for(int i = 1; i <= n; ++ i)
    {
        for(int j = 1; j <= n; ++ j)
        {
            char ch;
            std::cin >> ch;
            mat[i][j] = -(ch != '.');
            would[i][j] = (ch != '.');
        }
    }
}

void val(int n)
{
    for(int i = 1; i <= n; ++ i)
    {
        for(int j = 1; j <= n; ++ j)
        {
            if(mat[i][j] == -1)
            {
                continue;
            }
            for(int a = -1; a <= 1; ++ a)
            {
                for(int b = -1; b <= 1; ++ b)
                {
                    if(!(a == 0 && b == 0) && mat[i + a][j + b] == -1)
                    {
                        ++ mat[i][j];
                    }
                }
            }
        }
    }
}

void would_fill(int n, int i, int j)
{
    if(i < 0 || i > n || j < 0 || j > n || would[i][j])
    {
        return;
    }

    would[i][j] = true;

    if(mat[i][j])
    {
        return;
    }

    for(int a = -1; a <= 1; ++ a)
    {
        for(int b = -1; b <= 1; ++ b)
        {
            would_fill(n, i + a, j + b);
        }
    }
}

void _would_fill(int n)
{
    for(int i = 1; i <= n; ++ i)
    {
        for(int j = 1; j <= n; ++ j)
        {
            if(!mat[i][j] && !would[i][j])
            {
                would_fill(n, i, j);
                ++ ans;
            }
        }
    }
}

void __would_fill(int n)
{
    for(int i = 1; i <= n; ++ i)
    {
        for(int j = 1; j <= n; ++ j)
        {
            if(!would[i][j])
            {
                ++ ans;
            }
        }
    }
}

void print_mat(int n)
{
    for(int i = 1; i <= n; ++ i)
    {
        for(int j = 1; j <= n; ++ j)
        {
            if(mat[i][j] >= 0)
            {
                std::cout << ' ';
            }
            std::cout << ' ' << mat[i][j];
        }
        std::cout << '\n';
    }
}

void print_would(int n)
{
    for(int i = 1; i <= n; ++ i)
    {
        for(int j = 1; j <= n; ++ j)
        {
            std::cout << would[i][j];
        }
        std::cout << '\n';
    }
}

int main()
{
    std::cin.tie();
    std::ios_base::sync_with_stdio(false);

    _fill(MAX_N);

    int n;
    std::cin >> n;
    read(n);
    //print_mat(n);
    //std::cout << '\n';

    val(n);
    //print_mat(n);
    //std::cout << '\n';

    _would_fill(n);
    //print_would(n);
    //std::cout << ans << '\n';
    __would_fill(n);
    //print_would(n);
    //std::cout << '\n';
    std::cout << ans << '\n';
    return 0;
}
/*
9
...@..@..
.........
.........
...@..@..
....@....
.........
@@..@...@
.......@.
.........
*/
