#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
pair<int,int>dirs[]={{0,-1},{0,1},{1,0},{-1,0},{1,-1},{1,1},{-1,-1},{-1,1}};
char mine[1005][1005];
bool used[1005][1005];
int n;
void bfs(int x,int y){
    queue<pair<int,int>>q;
    q.push({x,y});
    used[x][y]=true;
    while(!q.empty()){
        int qx=q.front().first,qy=q.front().second;
        q.pop();
        bool is_bomb=false;
        for(int i=0;i<8;i++){
            int curr_x=qx+dirs[i].first,curr_y=qy+dirs[i].second;
            if(curr_x>-1 and curr_y>-1 and curr_x<n and curr_y<n){
                if(mine[curr_x][curr_y]=='@'){
                    is_bomb=true;
                    break;
                }
            }
        }
        if(x==0 and y==0) cout<<qx<<" "<<qy<<" "<<boolalpha<<is_bomb<<endl;
        if(!is_bomb){
            for(int i=0;i<8;i++){
                int curr_x=qx+dirs[i].first,curr_y=qy+dirs[i].second;
                if(curr_x>-1 and curr_y>-1 and curr_x<n and curr_y<n){
                    if(!used[curr_x][curr_y]){
                        q.push({curr_x,curr_y});
                        used[curr_x][curr_y]=true;
                        if(x==0 and y==0) cout<<"("<<curr_x<<","<<curr_y<<")\n";
                    }
                }
            }
        }
    }
}
int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin>>n;
    for(int i=0;i<n;i++){
        for(int i2=0;i2<n;i2++){
            cin>>mine[i][i2];
        }
    }
    int clicks=0;
    for(int i=0;i<n;i++){
        for(int i2=0;i2<n;i2++){
            if(!used[i][i2] and mine[i][i2]=='.'){
                //cout<<i<<" "<<i2<<endl;
                bfs(i,i2);
                clicks++;
            }
        }
    }
    cout<<clicks<<endl;
return 0;
}
/**
9
...@..@..
.........
.........
...@..@..
....@....
.........
@@..@...@
.......@.
.........
*/
