#include<iostream>
#include<utility>
#include<queue>
using namespace std;

int n;
char a[1024][1024];
int cnt[1024][1024];
int used[1024][1024];

int br;

void BFS(int i,int j)
{
    queue< pair<int,int> > q;
    q.push(make_pair(i,j));

    pair<int,int> p;
    while(!q.empty())
    {
        p=q.front();
        q.pop();
        i=p.first;
        j=p.second;
        if(a[i][j]!='@' and cnt[i][j]==0 and !used[i][j])
        {
            used[i][j]++;
            br++;
            if(i>0 and j>0) q.push(make_pair(i-1,j-1));
            if(i>0) q.push(make_pair(i-1,j));
            if(i>0 and j<n-1) q.push(make_pair(i-1,j+1));
            if(j>0) q.push(make_pair(i,j-1));
            if(j<n-1) q.push(make_pair(i,j+1));
            if(i<n-1 and j>0) q.push(make_pair(i+1,j-1));
            if(i<n-1) q.push(make_pair(i+1,j));
            if(i<n-1 and j<n-1) q.push(make_pair(i+1,j+1));
        }
        else if(a[i][j]!='@' and !used[i][j])
        {
            used[i][j]++;
            br++;
        }
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;

    for(int i=0; i<n; i++)
        for(int j=0; j<n; j++)
            cin >> a[i][j];

    int cnt_mines=0;
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<n; j++)
        {
            if(a[i][j]=='@')
            {
                cnt_mines++;
                continue;
            }
            if(i>0 and j>0 and a[i-1][j-1]=='@') cnt[i][j]++;
            if(i>0 and a[i-1][j]=='@') cnt[i][j]++;
            if(i>0 and j<n-1 and a[i-1][j+1]=='@') cnt[i][j]++;
            if(j>0 and a[i][j-1]=='@') cnt[i][j]++;
            if(j<n-1 and a[i][j+1]=='@') cnt[i][j]++;
            if(i<n-1 and j>0 and a[i+1][j-1]=='@') cnt[i][j]++;
            if(i<n-1 and a[i+1][j]=='@') cnt[i][j]++;
            if(i<n-1 and j<n-1 and a[i+1][j+1]=='@') cnt[i][j]++;
        }
    }

    br=0;
    int ans=0;
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<n; j++)
        {
            if(a[i][j]!='@' and cnt[i][j]==0 and !used[i][j])
            {
                BFS(i,j);
                ans++;
            }
        }
    }

    cout << ans+n*n-cnt_mines-br << endl;

    return 0;
}
