#include <bits/stdc++.h>
using namespace std;

int minefield[1005][1005];
int n;
int out=0;


 bool isValid(int i, int j){
    return i>=0&&i<n&&j>=0&&j<n;
 }
int hasMines(int i, int j){
    if(minefield[i][j]==-1){
        return -1;
    }
    //==================
    if(isValid(i-1, j)){
        if(minefield[i-1][j]==-1){
            return 1;
        }
    }
    if(isValid(i-1, j+1)){
        if(minefield[i-1][j+1]==-1){
            return 1;
        }
    }
    if(isValid(i, j+1)){
        if(minefield[i][j+1]==-1){
            return 1;
        }
    }
    if(isValid(i+1, j+1)){
        if(minefield[i+1][j+1]==-1){
            return 1;
        }
    }
    if(isValid(i+1, j)){
        if(minefield[i+1][j]==-1){
            return 1;
        }
    }
    if(isValid(i+1, j-1)){
        if(minefield[i+1][j-1]==-1){
            return 1;
        }
    }
    if(isValid(i, j-1)){
        if(minefield[i][j-1]==-1){
            return 1;
        }
    }
    if(isValid(i-1, j-1)){
        if(minefield[i-1][j-1]==-1){
            return 1;
        }
    }
    return 0;
}

int isBorder(int i,int j){
    if(minefield[i][j]==-1){
        return -1;
    }
    if(minefield[i][j]==0){
        return 0;
    }
    //==================
    if(isValid(i-1, j)){
        if(minefield[i-1][j]==0){
            return 1;
        }
    }
    if(isValid(i-1, j+1)){
        if(minefield[i-1][j+1]==0){
            return 1;
        }
    }
    if(isValid(i, j+1)){
        if(minefield[i][j+1]==0){
            return 1;
        }
    }
    if(isValid(i+1, j+1)){
        if(minefield[i+1][j+1]==0){
            return 1;
        }
    }
    if(isValid(i+1, j)){
        if(minefield[i+1][j]==0){
            return 1;
        }
    }
    if(isValid(i+1, j-1)){
        if(minefield[i+1][j-1]==0){
            return 1;
        }
    }
    if(isValid(i, j-1)){
        if(minefield[i][j-1]==0){
            return 1;
        }
    }
    if(isValid(i-1, j-1)){
        if(minefield[i-1][j-1]==0){
            return 1;
        }
    }
    return 2;
}

void click(int i, int j){
    if(!isValid(i, j)){
        return;
    }
    if(minefield[i][j]!=0){
        minefield[i][j]=-1;
        return;
    }
    else{
        minefield[i][j]=-1;
        click(i-1, j);
        click(i-1, j+1);
        click(i, j+1);
        click(i+1, j+1);
        click(i+1, j);
        click(i+1, j-1);
        click(i, j-1);
        click(i-1, j-1);
    }
    return;
}

int main(){
    cin>>n;
    for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            char c;
            cin>>c;
            int mine;
            switch(c){
                case '.':mine=0;break;
                case '@':mine=-1;break;
            }
            minefield[i][j]=mine;
        }
    }
    for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            minefield[i][j]=hasMines(i, j);
        }
    }
    for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            minefield[i][j]=isBorder(i, j);
        }
    }
    /**test cout
    for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            if(minefield[i][j]>=0){cout<<' ';}
            cout<<minefield[i][j];
        }
        cout<<endl;
    }
    **/
    for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            if(minefield[i][j]!=1&&minefield[i][j]!=-1){
                out++;
                click(i, j);
                //cout<<i<<' '<<j<<endl;
            }
        }
    }
    cout<<out<<endl;
}
/**
9
...@..@..
.........
.........
...@..@..
....@....
.........
@@..@...@
.......@.
.........
**/
