#include<iostream>
#include<vector>
#include<queue>
using namespace std;

long long mat[1024][1024];
long long st[1024][1024];
long long n, found, mine, ans;
char vh;
bool used[1024][1024];
vector<pair<long long, long long> > open;
queue<pair<long long, long long> > bfs;

void dfs(long long x, long long y)
{
    //if(used[x][y]){
        //return;
    //}
    used[x][y] = true;
    found++;
    if(st[x][y] > 0){
        return;
    }
    if(x > 1){
        if(y > 1){
            if(!used[x-1][y-1]){
                bfs.push({x-1, y-1});
                used[x-1][y-1] = true;
            }
        }
        if(!used[x-1][y]){
            bfs.push({x-1, y});
            used[x-1][y] = true;
        }
        if(y < n && !used[x-1][y+1]){
            bfs.push({x-1, y+1});
            used[x-1][y+1] = true;
        }
    }

    if(y > 1 && !used[x][y-1]){
        bfs.push({x, y-1});
        used[x][y-1] = true;
    }
    if(y < n && !used[x][y+1]){
        bfs.push({x, y+1});
        used[x][y+1] = true;
    }

    if(x < n){
        if(y > 1 && !used[x+1][y-1]){
            bfs.push({x+1, y-1});
            used[x+1][y-1] = true;
        }
        if(!used[x+1][y]){
            bfs.push({x+1, y});
            used[x+1][y] = true;
        }
        if(y < n && !used[x+1][y+1]){
            bfs.push({x+1, y+1});
            used[x+1][y+1] = true;
        }
    }
}

int main(){
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);
    //cout.tie(NULL);
    //fixed(cout);
    cin >> n;

    for(long long i = 1; i <= n; i++){
        for(long long j = 1; j <= n; j++){
            cin >> vh;
            if(vh == '@'){
                mat[i][j] = 1;
                mine++;
            }
        }
        //cout << "plqs" << " " << i << endl;
    }
    /*
    while(true){
        cout << "fin\n";
    }*/
    for(long long i = 1; i <= n; i++){
        for(long long j = 1; j <= n; j++){
            if(mat[i][j]){
                st[i][j] = 9;
                continue;
            }
            st[i][j] = mat[i-1][j-1] + mat[i-1][j] + mat[i-1][j+1] + mat[i][j-1]
                     + mat[i][j+1] + mat[i+1][j-1] + mat[i+1][j] + mat[i+1][j+1];
            if(st[i][j] == 0){
                open.push_back({i, j});
                //cout << i << " " << j << endl;
            }
            //cout << st[i][j];
        }
        //cout << endl;
    }
    /*while(true){
        cout << "fin\n";
    }*/
    for(long long k = 0; k < open.size(); k++){
        pair<long long, long long> dot = open[k];
        long long x = dot.first;
        long long y = dot.second;
        //open.pop();
        //while(true){
            //cout << "fin\n";
        //}
        if(!used[x][y]){
            ans++;
            bfs.push({x, y});
            while(!bfs.empty()){
                pair<long long, long long> dot1 = bfs.front();
                long long x1 = dot1.first;
                long long y1 = dot1.second;
                dfs(x1, y1);
                //cout << x1 << " " << y1 << endl;
                bfs.pop();
            }
            //cout << x << " " << y << " " << found << endl;
        }
        /*while(true){
            cout << "fin\n";
        }*/
        //cout << k << endl;
    }
    ans += n*n - found - mine;
    /*for(long long i = 1; i <= n; i++){
        for(long long j = 1; j <= n; j++){
            if(!used[i][j]){

            }
        }
    }*/
    cout << ans << endl;
return 0;
}
/*
9
...@..@..
.........
.........
...@..@..
....@....
.........
@@..@...@
.......@.
.........
*/
